/*
 * Yury P. Fedorchenko 2001-2011
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <inkview.h>
#include "main.h"
#include "bitmaps.h"

struct FIELD field_array[12][25];
struct PTS point_T_STR;
struct T_STR t_f[N_T_STR],*t_work=NULL;
int game_type=2;
int theme=1;
extern int level,level_old;
extern int drop_is_ok,drop_is_animated,show_buttons,drop_at_right,small_but,use_gsensor;
static int mitem=0;

//int game_fone=1,game_music=1,game_sound=1;
// pb vars
ifont* boardf,*boardf_half;
ifont* helpf;

int SCREEN_W=600;
int SCREEN_H=800;
//
static char *theme_v[] = {"Simple", "Leaves", NULL };
static char *type_v[] = {"Tetris","Pentix","Tetra+Penta","Extended", NULL };
static char *level_v[] = {"0","1","2","3","4","5","6","7","8","9", NULL };
static char *drop_v[] = {"Rotate", "Drop", NULL };
static char *noyes_v[] = {"No", "Yes", NULL };
static char *yesno_v[] = {"Yes", "No", NULL };


static iconfig *ttrcfg = NULL;

static iconfigedit ttrcfge[] = {
//int type;const ibitmap *icon;char *text;char *hint;char *name;char *deflt;char **variants;struct iconfigedit_s *submenu;
//{CFG_INFO,NULL              ,""          ,NULL      ,""        ,""         ,NULL           ,NULL},
  {CFG_INDEX,NULL             ,"theme"       ,NULL     ,"ch.theme","0"        ,theme_v  ,NULL},
  {CFG_INDEX,NULL             ,"game type"   ,NULL     ,"ch.type" ,"0"        ,type_v   ,NULL},
  {CFG_INDEX,NULL             ,"start level" ,NULL     ,"ch.level","0"        ,level_v  ,NULL},
  {CFG_INDEX,NULL             ,"OK button"   ,NULL     ,"ch.drop" ,"0"        ,drop_v   ,NULL},
  {CFG_INDEX,NULL             ,"Animate Drop",NULL     ,"ch.animate","1"      ,yesno_v  ,NULL},
  {CFG_INDEX,NULL             ,"Show buttons",NULL     ,"ch.buttons","0"      ,yesno_v  ,NULL},
  {CFG_INDEX,NULL             ,"Small buttons",NULL    ,"ch.buttype","0"      ,yesno_v  ,NULL},
  {CFG_INDEX,NULL             ,"Drop at right",NULL    ,"ch.butpos","0"       ,yesno_v  ,NULL},
  {CFG_INDEX,NULL             ,"Use G-Sensor" ,NULL    ,"ch.gsensor","0"      ,noyes_v  ,NULL},
  {0}
}; 

void tetris();
void about();
void main_menu();
int main_handler(int type, int par1, int par2);

void apply_config(){
  theme=ReadInt(ttrcfg,"ch.theme",1);
  game_type=ReadInt(ttrcfg,"ch.type",0);
  level_old=level=ReadInt(ttrcfg,"ch.level",1);
  drop_is_ok=ReadInt(ttrcfg,"ch.drop",0);
  drop_is_animated=!ReadInt(ttrcfg,"ch.animate",0);
  show_buttons=!ReadInt(ttrcfg,"ch.buttons",0);
  drop_at_right=!ReadInt(ttrcfg,"ch.butpos",0);
  small_but=!ReadInt(ttrcfg,"ch.buttype",QueryTouchpanel());
  use_gsensor=QueryGSensor()?ReadInt(ttrcfg,"ch.gsensor",0):0;
}

static void config_ok() {
  int ret=SaveConfig(ttrcfg);
  apply_config();
  SendEvent(main_handler,EVT_SHOW,0,0);
}

int get_item(int x,int y){
  int i;
  for(i=0;i<4;i++){
    if(y> (4+i)*SCREEN_H/10 && y<(4+i)*SCREEN_H/10+40 && x>SCREEN_W/2-40){
      mitem=i;
      main_menu();
      return mitem;
    }
  }
  main_menu();
  return -1;
}
void main_menu()
{  
  int i;
  char *name[4]={"New Game","Options","About","Quit"};
  ClearScreen();
  DrawBitmap(0,0,&title);
  for(i=0;i<4;i++){
    SetFont(boardf,mitem==i?BLACK:DGRAY);
    if(mitem==i)DrawBitmap(SCREEN_W/2-40,(4+i)*SCREEN_H/10,&c1);
    DrawString(SCREEN_W/2,(4+i)*SCREEN_H/10,name[i]);
  }
  SoftUpdate();
}
void do_main_menu(){
  switch(mitem){
    case 0:
      ClearScreen();
      tetris();
      ClearScreen();
      break;
    case 1:
      OpenConfigEditor("Configuration", ttrcfg, ttrcfge, config_ok, NULL);
      break;
    case 2:
      about();
      break;
    case 3:
      CloseApp();
   }
}
void about()
{
  int i;
  char* name[9]={"",
"\"Fall Of Leaves\" v 1.2.2 PB edition",
"",
"Yury Fedorchenko 2009-2011",
"",
"http://www.fedorchenko.net",
"",
"This program is free software distributed under",
"the terms of the GNU General Public License"
};
  ClearScreen();
  DrawBitmap(0,0,&title);
  SetFont(boardf,BLACK);
    for(i=0;i<9;i++){
    if(i>6)  SetFont(helpf,BLACK);

    DrawTextRect(0,250+i*25,600,20,name[i],ALIGN_CENTER);
    }
  SoftUpdate();
}


#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>

struct hsrec{
  char name[128];
  int score;
  int level;
  int lines;
} cscore[10];

#define HSCOREFILE  USERDATA"/state/fallofleaves.hscore"

void hiscore(){
  int ret,top=0;
  struct hsrec a;
  int fd=open(HSCOREFILE,O_RDONLY, S_IWUSR|S_IRUSR|S_IWGRP|S_IRGRP);
  printf(HSCOREFILE"\n");
  if(fd>0){
    do{
      ret=read(fd,&a,sizeof(struct hsrec));
      if(ret>0)memcpy(&cscore[top],&a,sizeof(struct hsrec));
    }while(ret<=0 || ++top>10);
    close(fd);
  }
}
void writehscore(){
  int i;
  int fd=open(HSCOREFILE,O_WRONLY|O_CREAT|O_TRUNC, S_IWUSR|S_IRUSR|S_IWGRP|S_IRGRP);
  if(fd>=0){
    for(i=0;i<10;++i){
      write(fd,&cscore[i],sizeof(struct hsrec));
    }
  }
}
void showhiscore(){
  hiscore();
  ClearScreen();
  DrawBitmap(0,0,&title);
  SetFont(boardf,BLACK);
  int i;
  char cscr[256];
  for(i=0;i<10;++i){
    sprintf(cscr,"%16s %10d %10d %10d",cscore[i].name,cscore[i].score,cscore[i].lines,cscore[i].level);    
    DrawString(0,(8+i)*SCREEN_H/20,cscr);
  }
  SoftUpdate();
}
static char the_string[128];
static struct hsrec tmp;
void kbr(char*s){
  printf("%s\n",the_string);
  if(s && *s){
  strcpy(tmp.name,s);
  }else{
  strcpy(tmp.name,"Unknown");
  }
  struct hsrec t2;
  int i=0;
  for(i=0;i<10;++i){
    if(cscore[i].score<tmp.score){
      memcpy(&t2,&cscore[i],sizeof(struct hsrec));
      memcpy(&cscore[i],&tmp,sizeof(struct hsrec));
      memcpy(&tmp,&t2,sizeof(struct hsrec));
    }
  }
  writehscore();
  showhiscore();
    
}

void update_hscr(int score,int level,int lines){
  tmp.score=score;
  tmp.level=level;
  tmp.lines=lines;
  OpenKeyboard("Name",the_string,128,0,kbr);
}

int main_handler(int type, int par1, int par2)
{
  if (type == EVT_INIT) {
    SetOrientation(0);
    boardf=OpenFont("cour",28,1);
    boardf_half=OpenFont("cour",14,1);
    helpf=OpenFont("cour",12,1);
    ttrcfg = OpenConfig(USERDATA"/config/falltrix.cfg", ttrcfge);
    apply_config();
    srand(time(NULL));
    filling_T_STR();
    hiscore();
  }

  if (type == EVT_SHOW) {
    ClearScreen();
    main_menu();
  }

  if (type == EVT_KEYPRESS || type == EVT_KEYREPEAT ) {
    switch (par1) {

    case KEY_OK:
      do_main_menu();
      return 1;
    case KEY_BACK:
    case KEY_LEFT:
    case KEY_RIGHT:
      main_menu();
      return 1;
    case KEY_UP:
      --mitem;if(mitem<0)mitem=3;
      main_menu();
      break;
    case KEY_DOWN:
      ++mitem;if(mitem>3)mitem=0;
      main_menu();
      break;
    }
  }
  if( EVT_POINTERDOWN == type ){
    if( get_item(par1,par2)!=-1) do_main_menu();
  }
  if (type == EVT_EXIT) {
  // occurs only in main handler when exiting or when SIGINT received.
  // save configuration here, if needed
  }
  return 0;
}

int main(int argc, char **argv)
{
	InkViewMain(main_handler);
	return 0;
}

