/*
 * Yury P. Fedorchenko 2001-2011
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <inkview.h>
#include "main.h"
#include "bitmaps.h"

extern struct FIELD field_array[12][25];

extern struct PTS point_T_STR;

extern struct T_STR t_f[N_T_STR], *t_work;

extern int SCREEN_W;
extern int SCREEN_H;
extern int game_type;
extern int theme;
ibitmap *cell[]={&c1,&c2,&c3,&c4,&c5,&c6,&c7,&c8};

const int CELL_SIZE=32;
#define LEFT_SIDE (int)((SCREEN_W/2)-6*(CELL_SIZE))
#define RIGHT_SIDE (int)((SCREEN_W/2)+6*(CELL_SIZE))

int ind_next;
int kind_cell,kind_cell_next;
//game vars
int falling,lines_sum = 0,level = 1,score = 0,line_rem = 0;
int level_old = 1;
int drop_is_ok,drop_is_animated,show_buttons,drop_at_right,small_but,use_gsensor;

extern ifont* boardf;
extern ifont* helpf;

extern int main_handler(int type, int par1, int par2);
int game_handler(int type, int par1, int par2);

int get_next(){
  int ret = rand() % N_T_STR;
  if(game_type==0)ret = rand() % N_T_STR_TETRA;
  if(game_type==1)ret = N_T_STR_TETRA + rand() % N_T_STR_PENTA;
  if(game_type==2)ret = rand() % N_T_STR_EXTRA;
  if(game_type==3)ret = rand() % N_T_STR;
  //printf("gt:%d %d - %d\n",game_type,ret,t_f[ret].n);
  return ret;
}

void screen_draw();
void draw_preview();
int  m_pause();
void filling_field();
int  line_remove();


// filling field
void filling_field()
{
  int k;
  for (k = 0; k < (*t_work).n; k++) {
	  field_array[point_T_STR.x + (*t_work).delt[k].x]
	             [point_T_STR.y + (*t_work).delt[k].y].buisy = kind_cell;
  }
}

// removing line
int line_remove()
{
  int i,j,k,ln_ok = 1,
	ln_sum = 0;
  for (i = 0; i < 22; i++) {
	  ln_ok = 1;
	  for (j = 0; j < 12; j++) {
	    if (field_array[j][i].buisy == 0)
		    ln_ok = 0;
	  }
	  if (ln_ok == 1) {
	    ln_sum++;
	    for (k = i; k < 22; k++) {
		    for (j = 0; j < 12; j++) {
		      field_array[j][k].buisy = field_array[j][k + 1].buisy;
		    }
	    }
	    i--;
	  }
  }
  return ln_sum;
}
// drawing game
int x1o,y1o,x2o,y2o;

void part_draw(){
  int k;
  for(k=0;k<(*t_work).n;k++){
    if(theme==0){
	DrawBitmap(field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].x,
               field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].y,
               &snow);
	DrawRect(field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].x,
             field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].y,
             CELL_SIZE,CELL_SIZE,BLACK);
    }
    else DrawBitmap(field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].x,
               field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].y,
               cell[kind_cell-1]);
/*    if(x1>field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].x)
       x1=field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].x;
    //if(x2<field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].x)
      // x2=field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].x;
    if(y1>field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].y)
       y1=field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].y;
    //if(y2<field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].y)
      // y2=field_array[ point_T_STR.x+(*t_work).delt[k].x ][ point_T_STR.y+(*t_work).delt[k].y ].y;
*/
  }
}
struct s_button but[5]={
 {"L"  ,5  ,490,90,0},
 {"R"  ,505,490,90,0},
 {"CCW" ,5  ,390,90,0},
 {"CW",505,390,90,0},
 
 {"DROP",5,590,90,0},
};

void screen_draw()
{
  ClearScreen();
  FillArea(LEFT_SIDE,0,12*CELL_SIZE,21*CELL_SIZE,WHITE);
  int i,j;
  for (i = 1; i < 8; i++) {
    DrawLine(LEFT_SIDE - 1 - i, 0, LEFT_SIDE - 1 - i,21 * CELL_SIZE + i,BLACK);
    DrawLine(RIGHT_SIDE + i, 0, RIGHT_SIDE + i, 21 * CELL_SIZE + i,BLACK);
    DrawLine(LEFT_SIDE - i, 21 * CELL_SIZE + i, RIGHT_SIDE + i,	     21 * CELL_SIZE + i,BLACK);
  }
  for (i = 0; i < 12; i++) {
    for (j = 0; j < 21; j++) {
      if (field_array[i][j].buisy != 0) {
        if(field_array[i][j].buisy){
          if(theme==0){
            DrawBitmap(field_array[i][j].x, field_array[i][j].y,&snow);
            DrawRect(field_array[i][j].x, field_array[i][j].y,CELL_SIZE, CELL_SIZE,BLACK);
          }else DrawBitmap(field_array[i][j].x, field_array[i][j].y,cell[field_array[i][j].buisy-1]);
        }
      };
    };
  }
  part_draw();
  //
  if(show_buttons)for(i=0;i<sizeof(but)/sizeof(struct s_button);++i)but_draw(&but[i]);
  PartialUpdateBW(0,0,600,21*CELL_SIZE);
}
// draw preview
void draw_preview()
{
  DrawRect(0,21*CELL_SIZE,SCREEN_W,5*CELL_SIZE,WHITE);
  SetFont(boardf,BLACK);
  char str[128];
  sprintf(str,"Lines :%d",lines_sum);
  DrawString(LEFT_SIDE,22*CELL_SIZE,str);
  sprintf(str,"Score :%d", score);
  DrawString(LEFT_SIDE,22.75*CELL_SIZE,str);
  sprintf(str,"Level :%d", level);
  DrawString(LEFT_SIDE,23.5*CELL_SIZE,str);
  DrawString(SCREEN_W/2,22*CELL_SIZE,"Next:");
  int k;
  for (k = 0; k < t_f[ind_next].n; k++) {
    /*if(theme==0)	 */ DrawRect(SCREEN_W/2+100+t_f[ind_next].delt[k].x*CELL_SIZE/2,
	             23*CELL_SIZE-t_f[ind_next].delt[k].y*CELL_SIZE/2,CELL_SIZE/2,CELL_SIZE/2,BLACK);

	 /* else DrawBitmap(SCREEN_W/2+t_f[ind_next].delt[k].x,
	             22*CELL_SIZE+t_f[ind_next].delt[k].y,cell[kind_cell_next]); */
  }
  SetFont(helpf,WHITE);
  FillArea(0,SCREEN_H-16,SCREEN_W,5*CELL_SIZE,BLACK);
  DrawString(0,SCREEN_H-16,"  Up/Down-rotate    Left/Right - move    Ok - Drop     Back - menu");
  PartialUpdateBW(0,21*CELL_SIZE,SCREEN_W,SCREEN_H-21*CELL_SIZE);
}

void sensor_timer(){
  int x,y,z;
  //char str[64];
  //static int x_old=-1000,y_old=-1000,z_old=-1000;
  if(use_gsensor){
    if(ReadGSensor(&x,&y,&z)){
      //manipulate with gsensor
      /*if(x_old!=-1000 && (x-x_old)>70 )but_click(&but[2]);//cw
      else if(x_old!=-1000 && (x_old-x)>70 )but_click(&but[3]);//ccw
      else if(x > 50)but_click(&but[0]);//left
      else if(x < -50)but_click(&but[1]);//right
      else if(x_old!=-1000 && (y_old-y)>70 )but_click(&but[2]);//drop need some idea
      else if(x_old!=-1000 && (y-y_old)>70 )but_click(&but[3]);//drop need some idea
      //else if (abs(x)<100 && abs(z)*/
      if(x > 90){but_click(&but[0]);screen_draw();}//left
      else if(x < -90){but_click(&but[1]);screen_draw();}//right
      else if( y>90 ){but_click(&but[2]);screen_draw();}//drop need some idea
      else if( y<-90 ){but_click(&but[3]);screen_draw();}//drop need some idea
      //els
      //x_old=x;y_old=y;z_old=z;
/*      sprintf(str,"%d %d %d",x,y,z);
  SetFont(helpf,BLACK);
  FillArea(0,0,5*CELL_SIZE,20,WHITE);
  DrawString(0,0,str);
  PartialUpdateBW(0,0,5*CELL_SIZE,20);*/
    }
  }
  if(falling<-20)ClearTimer(sensor_timer);
  else SetWeakTimer("gstimer",sensor_timer,(1000 - (90 * level))/5.);
}

void timer_proc(){
  int ndrop;
  falling = falling_T_STR(&ndrop);
  if(falling<-20){
    ClearTimer(timer_proc);
    ClearTimer(sensor_timer);
    screen_draw();
    SetFont(boardf,BLACK);
    DrawString(100,CELL_SIZE*22,"Game Over");
    FullUpdate();
    update_hscr(score,level,lines_sum);
    return;
  }
  if(falling<=0){
    filling_field();
    line_rem = line_remove();
    screen_draw();
    lines_sum += line_rem;
    level = level_old + (int) (lines_sum / 10);
    score += 5 * ((int) (point_T_STR.y / 4)) + 10 + (line_rem == 1) * 100 + (line_rem == 2) * 250 + (line_rem == 3) * 400 + (line_rem == 4) * 500;
    falling = 1;
    point_T_STR.x = 4;
    point_T_STR.y = 21;

    t_work = &t_f[ind_next];
    kind_cell = kind_cell_next;
    ind_next = get_next();
    kind_cell_next = 1 + rand() % 8;
    draw_preview();
  }else screen_draw();
  SetWeakTimer("Mytimer",timer_proc,(1000 - (90 * level)));
}
int hlobys(){
  int i=0;
  while(falling>0 && i==0){
    falling = falling_T_STR(&i);
    if(drop_is_animated)screen_draw();
  }
  if(!drop_is_animated)screen_draw();
  return i;
}
int pmitem;
void pause_menu()
{  
  screen_draw();
  int i;
  char *name[2]={"Continue","Leave Game"};
  for(i=0;i<2;i++){
    SetFont(boardf,pmitem==i?BLACK:DGRAY);
    if(pmitem==i)DrawBitmap(SCREEN_W/2-40,(4+i)*SCREEN_H/10,&c1);
    DrawString(SCREEN_W/2,(4+i)*SCREEN_H/10,name[i]);
  }
  SoftUpdate();
}
void do_pause_menu(){
  switch(pmitem){
    case 0:
      SetWeakTimer("Mytimer",timer_proc,(1000 - (90 * level)));
      if(use_gsensor)SetWeakTimer("gstimer",sensor_timer,(1000 - (90 * level))/5);
      SetEventHandler(game_handler);
      break;
    case 1:
      ClearTimer(timer_proc);
      ClearTimer(sensor_timer);
      SetEventHandler(main_handler);
      FullUpdate();
      break;
   }
}

int get_pitem(int x,int y){
  int i;
  for(i=0;i<2;i++){
    if(y> (4+i)*SCREEN_H/10 && y<(4+i)*SCREEN_H/10+40 && x>SCREEN_W/2-40){
      pmitem=i;
      pause_menu();
      return pmitem;
    }
  }
  pause_menu();
  return -1;
}

int pause_handler(int type,int par1,int par2){
  if (type == EVT_SHOW) {
     ClearScreen();
     pause_menu();
  }
  if(EVT_KEYPRESS == type){
    switch(par1){
      case KEY_OK:
      do_pause_menu();
    case KEY_UP:
      --pmitem;if(pmitem<0)pmitem=1;
      pause_menu();
      break;
    case KEY_DOWN:
      ++pmitem;if(pmitem>1)pmitem=0;
      pause_menu();
      break;
    }
  }
  if( EVT_POINTERDOWN == type ){
    if( get_pitem(par1,par2)!=-1) do_pause_menu();
  }
  return 1;
}

int game_handler(int type, int par1, int par2)
{
    int i=0;
    if (type == EVT_SHOW) {
        screen_draw();
    }

    if (type == EVT_KEYPRESS){// || type == EVT_KEYREPEAT ) {
        if(falling<-20){
          ClearTimer(timer_proc);
          ClearTimer(sensor_timer);
          SetEventHandler(main_handler);
          FullUpdate();
        }
    switch (par1) {
      case KEY_BACK:
      case KEY_MENU:
      case KEY_PREV:
      case KEY_PREV2:
        ClearTimer(timer_proc);
        ClearTimer(sensor_timer);
        SetEventHandler(pause_handler);
        FullUpdate();
        return 1;
    case KEY_DOWN:
      but_click(&but[drop_is_ok?3:4]);
      return 1;
      case KEY_UP:
        but_click(&but[2]);
        screen_draw();
      break;
      case KEY_OK:
        but_click(&but[drop_is_ok?4:3]);
        screen_draw();
      break;
      case KEY_LEFT:
        but_click(&but[0]);
        screen_draw();
      break;
      case KEY_RIGHT:
        but_click(&but[1]);
        screen_draw();
      break;

      }
    }
  if (type == EVT_POINTERDOWN || type == EVT_POINTERLONG) {
    for(i=0;i<sizeof(but)/sizeof(struct s_button);++i){
    if(but_inside(&but[i],par1,par2)){
      but_click(&but[i]);
      screen_draw();
      return 1;
    }
    }
  }
  if (type == EVT_EXIT) {
    // occurs only in main handler when exiting or when SIGINT received.
    // save configuration here, if needed
  }

  return 0;
}

void tetris(){
  but[0].pfun=left_move_T_STR;
  but[1].pfun=right_move_T_STR;
  but[2].pfun=ccw_rotate_T_STR;
  but[3].pfun=cw_rotate_T_STR;
  but[4].pfun=hlobys;
  but[4].x=drop_at_right?505:5;
  if(small_but){
    but[0].x=drop_at_right?505:5;
    but[1].x=drop_at_right?555:55;
    but[2].x=drop_at_right?505:5;
    but[3].x=drop_at_right?555:55;
    but[0].y=340;
    but[1].y=340;
    but[4].y=440;
    but[0].size=40;
    but[1].size=40;
    but[2].size=40;
    but[3].size=40;
/*   {"L"  ,5  ,490,90,0},
   {"R"  ,505,490,90,0},
   {"CW" ,5  ,390,90,0},
   {"CCW",505,390,90,0},

   {"DROP",5,590,90,0},*/
  }
  int i,j;
  falling = 0;
  for (i = 0; i < 12; i++) {
    for (j = 0; j < 25; j++) {
      field_array[i][j].x = LEFT_SIDE + i * (CELL_SIZE);
      field_array[i][j].y = (20 - j) * (CELL_SIZE);
      field_array[i][j].buisy = 0;
    }
  }
  level=level_old;
  score=0;
  lines_sum=0;
  point_T_STR.x = 4;
  point_T_STR.y = 21;

  kind_cell_next = 1 + rand() % 8;
  t_work = &t_f[get_next()];
  kind_cell = kind_cell_next;
  ind_next = get_next();
  kind_cell_next = 1 + rand() % 8;
  screen_draw();
  draw_preview();
  FullUpdate();
  falling = 1;

  SetWeakTimer("Mytimer",timer_proc,(1000 - (90 * level)));
  if(use_gsensor)SetWeakTimer("gstimer",sensor_timer,(1000 - (90 * level))/5);
  SetEventHandler(game_handler);
}

